<?php
		
	/**
	 * Modul zur Generierung von Anschreibenen
	 * @author Daschmi
	 */
	class wpsg_mod_coverletter extends wpsg_mod_basic {
		
		var $lizenz = 0;
		var $id = 2200;
		var $hilfeURL = 'http://wpshopgermany.maennchen1.de/?p=3667';
        var $version = "9.9.9";
		
		public function __construct() {
			
			parent::__construct();
			
			if (!defined('WPSG_TBL_COVERLETTER')) define('WPSG_TBL_COVERLETTER', $this->shop->prefix.'wpsg_coverletter');
			
			$this->name = __('Anschreiben', 'wpsg');
			$this->group = __('Bestellung', 'wpsg');
			$this->desc = __('Ermöglicht die Erstellung von Anschreibenen.', 'wpsg');
			
		} // public function __construct()
		
		public function init() {
			
			$this->fields = array(
				'company' => __('Firmenname', 'wpsg'),
				'name' => __('Name', 'wpsg'),
				'street' => __('Straße', 'wpsg'),
				'zipcity' => __('PLZ/Ort', 'wpsg'),
				'country' => __('Land', 'wpsg'),
				'tel' => __('Tel', 'wpsg'),
				'fax' => __('Fax', 'wpsg'),
				'mail' => __('E-Mail', 'wpsg'),
				'web' => __('Web', 'wpsg'),
				'taxnr' => __('Steuer-Nr', 'wpsg'),
				'ustidnr' => __('UStIdNr.', 'wpsg'),
				'bank' => __('Bank', 'wpsg'),
				'iban' => __('IBAN', 'wpsg'),
				'bic' => __('BIC', 'wpsg'),
				'user1' => __('Benutzer 1', 'wpsg'),
				'user2' => __('Benutzer 2', 'wpsg'),
				'user3' => __('Benutzer 3', 'wpsg'),
				'user4' => __('Benutzer 4', 'wpsg'),
				'user5' => __('Benutzer 5', 'wpsg')
			);
			
		} // public function init()
		 
		public function install() {
			
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
				
			/**
			 * Tabelle für die Lieferanten
			*/
			$sql = "CREATE TABLE ".WPSG_TBL_COVERLETTER." (
				id int(25) NOT NULL AUTO_INCREMENT,
				cdate DATETIME NOT NULL,
				order_id int(25) NOT NULL,
				text TEXT NOT NULL,
				KEY order_id (order_id), 
				PRIMARY KEY  (id) 
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
				 
			dbDelta($sql);  
			
		} // public function install()
		
		public function settings_edit() {
					
			$this->shop->view['wpsg_mod_coverletter']['fields'] = $this->fields;			
			$this->shop->view['wpsg_mod_coverletter']['arTexts'] = $this->shop->get_option('wpsg_mod_coverletter_texts');
			
			if (!is_array($this->shop->view['wpsg_mod_coverletter']['arTexts'])) $this->shop->view['wpsg_mod_coverletter']['arTexts'] = array();

			if (file_exists($this->getFilePath('').'wpsg_coverletter_bp.jpg')) {
				
				$this->shop->view['wpsg_mod_coverletter']['bp'] = $this->getFilePath('', true).'wpsg_coverletter_bp.jpg';
				
			} else if (file_exists($this->getFilePath('').'wpsg_coverletter_bp.pdf')) {
				
				$this->shop->view['wpsg_mod_coverletter']['bp'] = $this->getFilePath('', true).'wpsg_coverletter_bp.pdf';
				
			} else {
				
				$this->shop->view['wpsg_mod_coverletter']['bp'] = false;
				
			}

			if (file_exists($this->getFilePath('').'wpsg_coverletter_logo.jpg')) {
				
				$this->shop->view['wpsg_mod_coverletter']['logo'] = $this->getFilePath('', true).'wpsg_coverletter_logo.jpg';
				
			} else {
				
				$this->shop->view['wpsg_mod_coverletter']['logo'] = false;
				
			}

			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_coverletter/settings_edit.phtml');

		} // public function settings_edit()
		
		/**
		 * zeigt das Formular zum Drucken in der Bestellverwaltung
		 */
		public function order_view($order_id, &$arSidebarArray) {
			 
			$this->shop->view['mod_coverletter']['arCoverLetter'] = $this->db->fetchAssoc("
				SELECT
					CL.*
				FROM
					`".WPSG_TBL_COVERLETTER."` AS CL
				WHERE
					CL.`order_id` = '".wpsg_q($order_id)."'
			");
			
			$arSidebarArray[$this->id] = array(
				'title' => $this->name,
				'content' => $this->shop->render(WPSG_PATH_VIEW.'mods/mod_coverletter/order_view.phtml', false)
			);
			
		} // public function order_view_content($order_id)

		public function settings_save() {

			// Sanitization
			$_REQUEST['text'] = wpsg_sanitize("wpsg_txt_tbl", $_REQUEST['text']);

			$this->shop->update_option("wpsg_mod_coverletter_texts", $_REQUEST['text']); 

			if (file_exists($_FILES['wpsg_mod_coverletter_bp']['tmp_name'])) {

				$ending = strtolower(preg_replace("/(.*)\./", "", $_FILES['wpsg_mod_coverletter_bp']['name']));
 
				if ($ending != "jpg" && $ending != "jpeg" && $ending != "pdf") {
					
					$this->shop->addBackendError(__("Ungültiger Dateityp (Briefpapier) ! Es sind nur JPG und PDF Dateien erlaubt!", "wpsg"));
					
				} else if ($ending == "jpg" || $ending == "jpeg") {
					
					move_uploaded_file($_FILES['wpsg_mod_coverletter_bp']['tmp_name'], $this->getFilePath('').'wpsg_coverletter_bp.jpg');
					
				} else if ($ending == "pdf") {
					
					move_uploaded_file($_FILES['wpsg_mod_coverletter_bp']['tmp_name'], $this->getFilePath('').'wpsg_coverletter_bp.pdf');
					
				}

			} else if ((array_key_exists('wpsg_mod_coverletter_bp_del', $_REQUEST)) && ($_REQUEST['wpsg_mod_coverletter_bp_del'] == "1")) {

				@unlink($this->getFilePath('').'wpsg_coverletter_bp.jpg');
				@unlink($this->getFilePath('').'wpsg_coverletter_bp.pdf');

				$this->shop->addBackendMessage(__('Briefpapier wurde erfolgreich gelöscht.', 'wpsg'));

			}

			if (array_key_exists('wpsg_mod_coverletter_logo_position_left', $_REQUEST) && strpos($_REQUEST['wpsg_mod_coverletter_logo_position_left'], 'selected') !== false)
				$wpsg_mod_coverletter_logo_position = "left";

			if (array_key_exists('wpsg_mod_coverletter_logo_position_center', $_REQUEST) && strpos($_REQUEST['wpsg_mod_coverletter_logo_position_center'], 'selected') !== false)
				$wpsg_mod_coverletter_logo_position = "center";

			if (array_key_exists('wpsg_mod_coverletter_logo_position_right', $_REQUEST) && strpos($_REQUEST['wpsg_mod_coverletter_logo_position_right'], 'selected') !== false)
				$wpsg_mod_coverletter_logo_position = "right";
 
			if (file_exists($_FILES['wpsg_mod_coverletter_logo']['tmp_name'])) {

				$ending = strtolower(preg_replace("/(.*)\./", "", $_FILES['wpsg_mod_coverletter_logo']['name']));
				
				if ($ending != "jpg" && $ending != "jpeg") {
					
					$this->shop->addBackendError(__("Ungültiger Dateityp (Logo) ! Es sind nur JPG und PDF Dateien erlaubt!", "wpsg"));
					
				} else if ($ending == "jpg" || $ending == "jpeg") {
					
					move_uploaded_file($_FILES['wpsg_mod_coverletter_logo']['tmp_name'], $this->getFilePath('').'wpsg_coverletter_logo.jpg');
					
				}

			} else if ((array_key_exists('wpsg_mod_coverletter_logo_del', $_REQUEST)) && ($_REQUEST['wpsg_mod_coverletter_logo_del'] == "1")) {

				@unlink($this->getFilePath('').'wpsg_coverletter_logo.jpg');

				$this->shop->addBackendMessage(__('Logo wurde erfolgreich gelöscht.', 'wpsg'));

			}

			$bCheckTextField = false;
			
			foreach ($_REQUEST['text'] as $k => $v) {
			    
			    if (
			        !in_array($k, ['firma', 'name', 'strasse', 'plzort', 'land', 'tel', 'fax', 'mail', 'web', 'strnr', 'ustidnr', 'knr', 'blz', 'bank', 'user1', 'user2', 'user3', 'user4', 'user5']) ||
			        !wpsg_checkInput($v['text'], WPSG_SANITIZE_TEXTFIELD) ||
			        !wpsg_checkInput($v['x'], WPSG_SANITIZE_FLOAT) ||
			        !wpsg_checkInput($v['y'], WPSG_SANITIZE_FLOAT) ||
			        !wpsg_checkInput($v['color'], WPSG_SANITIZE_HEXCOLOR) ||
			        !wpsg_checkInput($v['fontsize'],WPSG_SANITIZE_INT)
			        ) {			           
			            
			            $this->shop->addBackendError(__('Bitte überprüfen Sie die Textfelder.', 'wpsg'));
			            $bCheckTextField = true;
			            
			        }
			        
			}
			
			if ($bCheckTextField) {
			    
			    $this->shop->update_option("wpsg_mod_coverletter_texte", $_REQUEST['text']);
			    
			}
			
			$this->shop->update_option('wpsg_mod_coverletter_subject', wpsg_getStr($_REQUEST['wpsg_mod_coverletter_subject'],'Anschreiben'), false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_coverletter_text', wpsg_getStr($_REQUEST['wpsg_mod_coverletter_text']), false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option("wpsg_mod_coverletter_logo_position", $wpsg_mod_coverletter_logo_position ? $wpsg_mod_coverletter_logo_position : null);
			$this->shop->update_option("wpsg_mod_coverletter_logo_transparency", $_REQUEST['wpsg_mod_coverletter_logo_transparency'], false, false, WPSG_SANITIZE_FLOAT);
			
			$this->shop->update_option('wpsg_mod_coverletter_logo_x', $_REQUEST['wpsg_mod_coverletter_logo_x'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_coverletter_logo_y', $_REQUEST['wpsg_mod_coverletter_logo_y'], false, false, WPSG_SANITIZE_TEXTFIELD);
			
		} // public function settings_save()
				
		public function order_ajax() {

			$_REQUEST['order_id'] = wpsg_sinput("key", $_REQUEST['order_id']);

			if (isset($_REQUEST['wpsg_mod_coverletter_preview'])) {
				
				$arCustomReplace = [];
				
				if (wpsg_getStr($_REQUEST['target'])	 === '2') {
					 
					$arCustomReplace = [
						'/%shopinfo_street%/i' => $this->shop->get_option('wpsg_shopdata_2_street'),
						'/%shopinfo_zip%/i' => $this->shop->get_option('wpsg_shopdata_2_zip'),
						'/%shopinfo_city%/i' => $this->shop->get_option('wpsg_shopdata_2_city'),
						'/%shopinfo_country%/i' => $this->shop->get_option('wpsg_shopdata_2_country'),
						'/%shopinfo_tel%/i' => $this->shop->get_option('wpsg_shopdata_2_tel'),
						'/%shopinfo_fax%/i' => $this->shop->get_option('wpsg_shopdata_2_fax'),
						'/%shopinfo_email%/i' => $this->shop->get_option('wpsg_shopdata_2_email')
					];
					
				}
								
				// Vorschau eines Anschreibenes aus der Bestellverwaltung
				$this->writeCoverLetter(
					wpsg_getInt($_REQUEST['edit_id']),
					$this->shop->get_option('wpsg_mod_coverletter_text'), 
					true,
					true,
					'coverletter-preview.pdf',
					$arCustomReplace
				);
			
				die();
				
			} else if (isset($_REQUEST['wpsg_mod_coverletter_get'])) {
				
				$order_id = intval(wpsg_sinput("key", $_REQUEST['order_id']));
				$cl_id = intval(wpsg_sinput("key", $_REQUEST['cl_id']));
				
				$file = $this->getFilePath($order_id).'coverletter_'.intval($cl_id).'.pdf';
				
				wpsg_header::PDFPlugin($file);
				
				exit;
				
			} else if (isset($_REQUEST['wpsg_mod_coverletter_write'])) {
				 
				if ($_REQUEST['edit_id'] <= 0) throw new \wpsg\Exception(__('Beim Erstellen des Anschreibendokumentes wurde keine BestellID übergeben', 'wpsg'));
				
				// In Datenbank eintragen
				$cl_id = $this->db->ImportQuery(WPSG_TBL_COVERLETTER, array(
					'order_id' => wpsg_q($_REQUEST['edit_id']),
					'cdate' => "NOW()",
					'text' => wpsg_q($_REQUEST['text'])
				));
				
				$filename = $this->getFilePath($_REQUEST['edit_id']).'/coverletter_'.$cl_id.'.pdf';
				
				$arCustomReplace = [];
				
				if ($_REQUEST['target'] === '2') {
				
					$arCustomReplace = [
						'/%shopinfo_street%/i' => $this->shop->get_option('wpsg_shopdata_2_street'),
						'/%shopinfo_zip%/i' => $this->shop->get_option('wpsg_shopdata_2_zip'),
						'/%shopinfo_city%/i' => $this->shop->get_option('wpsg_shopdata_2_city'),
						'/%shopinfo_country%/i' => $this->shop->get_option('wpsg_shopdata_2_country'),
						'/%shopinfo_tel%/i' => $this->shop->get_option('wpsg_shopdata_2_tel'),
						'/%shopinfo_fax%/i' => $this->shop->get_option('wpsg_shopdata_2_fax'),
						'/%shopinfo_email%/i' => $this->shop->get_option('wpsg_shopdata_2_email')
					];
					
				} 
				
				// Anschreiben erstellen
				$bOK = $this->writeCoverLetter(
					$_REQUEST['edit_id'], 
					$_REQUEST['text'], 
					false,
					$cl_id,
					$filename,
					$arCustomReplace
				);
				
				if ($bOK === true) {
				 
					if (!file_exists($filename) || !is_file($filename)) {
						
						$this->db->Query("DELETE FROM `".WPSG_TBL_COVERLETTER."` WHERE `id` = '".wpsg_q($cl_id)."'");
						
						throw new \wpsg\Exception(__('Das Anschreibendokument wurde nicht wie vorgesehen angelegt', 'wpsg'));
						
					}
					 										
					wpsg_header::PDFPlugin($filename);					
										
				}
				else
				{
					
					$this->db->Query("DELETE FROM `".WPSG_TBL_COVERLETTER."` WHERE `id` = '".wpsg_q($cl_id)."'");
					
					throw new \wpsg\Exception(__('Beim Erstellen des Anschreibendokumentes ist ein Fehler aufgetreten', 'wpsg'));
					
				}
				
			}
			
		} // public function order_ajax()
		
		public function delOrder($order_id) {
				
			// Anschreibene in der Datenbank löschen
			$this->db->Query("DELETE FROM `".WPSG_TBL_COVERLETTER."` WHERE `order_id` = '".wpsg_q($order_id)."'");
				
			// Anschreibene im Dateisystem löschen
			$path = $this->getFilePath($order_id); wpsg_rrmdir($path);
				
		} // public function delOrder($order_id)
					
		public function be_ajax() {
				
			if ($_REQUEST['do'] == 'reset') {
			
				$this->resetAction();
				$this->shop->addBackendMessage(__('Grundeinstellungen wieder hergestellt', 'wpsg'));
			
				$this->shop->redirect(WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Admin&action=module&modul='.$_REQUEST['modul']);
				
			} else if (wpsg_isSizedString($_REQUEST['do'], 'getBp')) {
				
				$file = '';
				
				if (file_exists($this->getFilePath('')."wpsg_coverletter_bp.pdf")) {
										
					$file = $this->getFilePath('')."wpsg_coverletter_bp.pdf";
					
					header('Content-Type: application/pdf');
					
				} else if (file_exists($this->getFilePath('')."wpsg_coverletter_bp.jpg")) {
					
					$file = $this->getFilePath('')."wpsg_coverletter_bp.jpg";
					
					header("Content-type: image/jpeg");
					
				}
				
				readfile($file);				
				
			} else if (wpsg_isSizedString($_REQUEST['do'], 'getLogo')) {
				
				$logo = $this->getFilePath('').'wpsg_coverletter_logo.jpg';
				
				header("Content-type: image/jpeg");
				readfile($logo);
				
			} else if ($_REQUEST['do'] == 'orderAjax') {

				$this->order_ajax();

			}			
			
		} // public function be_ajax()
		 
		/**
		 * Generiert das Anschreiben für eine Bestellung
		 */
		public function writeCoverLetter($order_id, $text, $preview, $clnr, $filename, $arCustomReplace = []) {

			$text = $this->shop->replaceUniversalPlatzhalter($text, $order_id);
			
			if ($preview === true && !wpsg_isSizedInt($order_id)) {
				
				$this->shop->view['order'] = [
					'onr' => __('Vorschau', 'wpsg'),
					'cdate' => date('d.m.Y')
				];
				$this->shop->view['customer'] = [
					'knr' => __('Vorschau', 'wpsg')
				];
				
			} else {
				
				$this->shop->view['order'] = $this->shop->cache->loadOrder($order_id);			
				$this->shop->view['customer'] = $this->shop->cache->loadKunden($this->shop->view['order']['k_id']);			
				$this->shop->view['data'] = array();
				
			}

			// Wurde die Bestellung in einer anderen Sprache gemacht
			if (trim(wpsg_getStr($this->shop->view['order']['language'])) != '') $this->shop->setTempLocale($this->shop->view['order']['language']);
			
			$oOrder = wpsg_order::getInstance($order_id);
			$this->shop->view['oOrder'] = $oOrder;
			
			// Rechnungsadresse		
			$this->shop->view['data']['id'] = wpsg_getStr($this->shop->view['customer']['id']);
			$this->shop->view['data']['company'] = wpsg_getStr($this->shop->view['customer']['firma']);
			$this->shop->view['data']['firstname'] = wpsg_getStr($this->shop->view['customer']['vname']);
			$this->shop->view['data']['name'] = wpsg_getStr($this->shop->view['customer']['name']);
			$this->shop->view['data']['street'] = wpsg_getStr($this->shop->view['customer']['strasse']);
			$this->shop->view['data']['hnr'] = wpsg_getStr($this->shop->view['customer']['nr']);
			$this->shop->view['data']['zip'] = wpsg_getStr($this->shop->view['customer']['plz']);
			$this->shop->view['data']['city'] = wpsg_getStr($this->shop->view['customer']['ort']);
			
			$this->shop->view['data']['country'] = '';			
			if ($oOrder->getInvoiceCountryID() !== $this->shop->getDefaultCountry(true)) $this->shop->view['data']['country'] = strtoupper($oOrder->getInvoiceCountryName());
 
			if ($preview === true && !wpsg_isSizedInt($order_id)) {
												
				$this->shop->view['data']['company'] = __('Musterfirma', 'wpsg');
				$this->shop->view['data']['firstname'] = __('Max', 'wpsg');
				$this->shop->view['data']['name'] = __('Mustermann', 'wpsg');
				$this->shop->view['data']['street'] = __('Musterstraße');
				$this->shop->view['data']['hnr'] = '1';
				$this->shop->view['data']['zip'] = '12345';
				$this->shop->view['data']['city'] = __('Musterhausen', 'wpsg');
				$this->shop->view['data']['country'] = ''; // strtoupper($this->shop->getDefaultCountry()->getName());
				
			}
			  			
			$this->shop->view['preview'] = $preview;
			$this->shop->view['filename'] = $filename; 			
			$this->shop->view['text'] = $text;
			
			// Benutzerdefinierte Felder
			$this->shop->view['arTexts'] = $this->shop->get_option('wpsg_mod_coverletter_texts');
			
			foreach ($this->shop->view['arTexts'] as $k => $t) {
				
				$this->shop->view['arTexts'][$k]['text'] = $this->shop->replaceUniversalPlatzhalter(
					$t['text'], 
					$oOrder->id,
					false,
					false,
					false,
					$arCustomReplace
				);
				
			}
			
			$this->shop->view['title'] = $this->shop->get_option('wpsg_mod_coverletter_subject');
			$this->shop->view['clnr'] = $clnr;
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_coverletter/coverletter_pdf.phtml');

			$this->shop->restoreTempLocale();
			
			return true;
			
		} // public function writeCoverLetter($order_id, $text, $preview, $nr, $filename) {
		 
		/**
		 * Lädt die Anschreibene einer Bestellung
		 * @param int $order_id ID der Bestellung
		 */
		public function getCoverLetterFromOrder($order_id) {
			
			return $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_COVERLETTER."` WHERE `order_id` = '".wpsg_q($order_id)."' "); 
			
		} // public function loadanschreibensFromOrder($order_id)
				
		/**
		 * Gibt den Absoluten Pfad zurück wo die Anschreibene gespeichert sind
		 */
		public function getFilePath($order_id, $url = false) {
		
			if ($order_id == '') {
			    
			    // Briefpapier/Logo
				if ($this->shop->isMultiBlog()) {
					
					$path = WPSG_PATH_CONTENT.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_coverletter/'.$order_id.'/';
					$url_content = WPSG_URL_CONTENT.WPSG_MB_UPLOADS.'/wpsg/wpsg_coverletter/';
					
					if ($url) $strReturn = $url_content.$order_id.'/';
					else $strReturn = $path;
					
				} else {
					
					$path = WPSG_PATH_CONTENT.'uploads/wpsg/wpsg_coverletter/'.$order_id.'/';
					
					if ($url) $strReturn = WPSG_URL_CONTENT.'uploads/wpsg/wpsg_coverletter/'.$order_id.'/';
					else $strReturn = $path.'/';
					
				}
				
			} else {
			    
			    // Anschreiben aus Bestellung
				$cl = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_COVERLETTER."` WHERE `order_id` = '".wpsg_q($order_id)."' ");
				$ym = date('Y/m', strtotime($cl['cdate'])).'/';
				
				if ($this->shop->isMultiBlog()) {
					
					$path = WPSG_PATH_CONTENT.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_coverletter/'.$ym.$order_id.'/';
					$url_content = WPSG_URL_CONTENT.WPSG_MB_UPLOADS.'/wpsg/wpsg_coverletter/'.$ym;
					
					if ($url) $strReturn = $url_content.$order_id.'/';
					else $strReturn = $path;
					
				} else {
					
					$path = WPSG_PATH_CONTENT.'uploads/wpsg/wpsg_coverletter/'.$ym.$order_id.'/';
					
					if ($url) $strReturn = WPSG_URL_CONTENT.'uploads/wpsg/wpsg_coverletter/'.$ym.$order_id.'/';
					else $strReturn = $path.'/';
					
				}
				
			} // if ($order_id == '')
			
			$this->shop->protectDirectory($path, [
                'wpsg_coverletter_logo.jpg', 'wpsg_coverletter_bp.jpg', 'wpsg_coverletter_bp.pdf'
            ] );	
            				
			return $strReturn;
		
		} // private function getFilePath($produkt_id, $url = false)
		
		/* Private Funktionen */ 
		
		/**
		 * Lädt die vordefinierten Textfelder
		 */
		private function resetAction() {
			
			$arData = array(
				"company" => array("aktiv" => "1", "x" => "24", "y" => "10", "fontsize" => 8, "text" => "%shopinfo_name%", "color" => "#000000"),
				"name" => array("aktiv" => "1", "x" => "24", "y" => "13", "fontsize" => 8, "text" => "Inh. %shopinfo_owner%", "color" => "#000000"),
				"street" => array("aktiv" => "1", "x" => "24", "y" => "16", "fontsize" => 8, "text" => "%shopinfo_street%", "color" => "#000000"),
				"zipcity" => array("aktiv" => "1", "x" => "24", "y" => "19", "fontsize" => 8, "text" => "%shopinfo_zip% %shopinfo_city%", "color" => "#000000"),
				"country" => array("aktiv" => "1", "x" => "24", "y" => "22", "fontsize" => 8, "text" => "%shopinfo_country%", "color" => "#000000"),
				"tel" => array("aktiv" => "1", "x" => "75", "y" => "10", "fontsize" => 8, "text" => "Tel. %shopinfo_tel%", "color" => "#000000"),
				"fax" => array("aktiv" => "1", "x" => "75", "y" => "13", "fontsize" => 8, "text" => "Fax. %shopinfo_fax%", "color" => "#000000"),
				"mail" => array("aktiv" => "1", "x" => "75", "y" => "16", "fontsize" => 8, "text" => "Mail: %shopinfo_email%", "color" => "#000000"),
				"web" => array("aktiv" => "1", "x" => "75", "y" => "19", "fontsize" => 8, "text" => "Web: ".site_url(), "color" => "#000000"),
				"taxnr" => array("aktiv" => "1", "x" => "145", "y" => "279", "fontsize" => 8, "text" => "Steuer-Nr.: %shopinfo_taxnr%", "color" => "#000000"),
				"ustidnr" => array("aktiv" => "1", "x" => "145", "y" => "282", "fontsize" => 8, "text" => "USt-IdNr.: %shopinfo_ustidnr%", "color" => "#000000"),
				"bank" => array("aktiv" => "1", "x" => "24", "y" => "279", "fontsize" => 8, "text" => "Bank: %shopinfo_bankname%", "color" => "#000000"),
				"iban" => array("aktiv" => "1", "x" => "24", "y" => "282", "fontsize" => 8, "text" => "IBAN: %shopinfo_iban%", "color" => "#000000"),
				"bic" => array("aktiv" => "1", "x" => "24", "y" => "285", "fontsize" => 8, "text" => "BLZ: %shopinfo_bic%", "color" => "#000000"),
			);
			
			$this->shop->update_option("wpsg_mod_coverletter_texts", $arData);
			
		} // public function resetAction()
		
	} // class wpsg_mod_coverletter extends wpsg_mod_basic
